using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace dobri_pravougaonici
{
    class Program
    {
        static void Main(string[] args)
        {
            string a = Convert.ToString(Console.ReadLine());
            string[] a1 = a.Split(' ');
            int n = Convert.ToInt32(a1[0]);
            int k = Convert.ToInt32(a1[1]);
            int[,] m = new int[n, n];
            for(int i = 0; i < n; i++)
            {
                string a2 = Convert.ToString(Console.ReadLine());
                string[] a3 = a2.Split(' ');
                for(int j = 0; j < n; j++)
                {
                    m[i, j] = Convert.ToInt32(a3[j]);
                }
            }
            int ukupno = 0;
            for(int l = 1; l <= k; l++)
            {
                int br = 0;
                for(int i = 0; i < n; i++)
                {
                    for (int j = 0; j < n; j++)
                    {
                        if (m[i, j] == l)
                        {
                            if (i != 0 && j != 0)
                            {
                                if ((m[i - 1, j] != l && m[i, j - 1] != l) || (m[i - 1, j] == l && m[i, j - 1] != l && m[i - 1, j - 1] == l) || (m[i, j - 1] == l && m[i - 1, j] != l && m[i - 1, j - 1] == l))
                                {
                                    br++;
                                }
                            }
                            else
                            {
                                if (i != 0)
                                {
                                    if (m[i - 1, j] != l)
                                    {
                                        br++;
                                    }
                                }
                                else
                                {
                                    if (j != 0)
                                    {
                                        if (m[i, j - 1] != l)
                                        {
                                            br++;
                                        }
                                    }
                                    else
                                    {
                                        br++;
                                    }
                                }
                            }
                        }
                    }
                }
                if (br == 1)
                {
                    ukupno++;
                }
            }
            Console.WriteLine("{0}", ukupno);
            Console.ReadLine();
        }
    }
}